WeakReference (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang.ref, class: WeakReference
Keywords: java.lang.ref.WeakReference class

# Class WeakReference<T>

java.lang.Object
java.lang.ref.Reference<T>
java.lang.ref.WeakReference<T>

Type Parameters:
  `T` - the type of the referent

public non-sealed class WeakReference<T> extends Reference<T>
Weak reference objects, which do not prevent their referents from being made finalizable, finalized, and then reclaimed. Weak references are most often used to implement canonicalizing mappings.

Suppose that the garbage collector determines at a certain point in time that an object is weakly reachable. At that time it will atomically clear all weak references to that object and all weak references to any other weakly-reachable objects from which that object is reachable through a chain of strong and soft references. At the same time it will declare all of the formerly weakly-reachable objects to be finalizable. At the same time or at some later time it will enqueue those newly-cleared weak references that are registered with reference queues.

Since:
  1.2

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `WeakReference(T referent)`
  Creates a new weak reference that refers to the given object.
  `WeakReference(T referent, ReferenceQueue<? super T> q)`
  Creates a new weak reference that refers to the given object and is registered with the given queue.

- ## Method Summary

  ### Methods declared in class Reference

  `clear, clone, enqueue, get, isEnqueued, reachabilityFence, refersTo`
  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  Clears this reference object.
  `protected Object`
  `clone()`
  Throws `CloneNotSupportedException`.
  `boolean`
  `enqueue()`
  Clears this reference object, then attempts to add it to the queue with which it is registered, if any.
  `T`
  `get()`
  Returns this reference object's referent.
  `boolean`
  `isEnqueued()`
  Deprecated.
  This method was originally specified to test if a reference object has been cleared and enqueued but was never implemented to do this test.
  `static void`
  `reachabilityFence(Object ref)`
  Ensures that the given object remains strongly reachable.
  `final boolean`
  `refersTo(T obj)`
  Tests if the referent of this reference object is `obj`.

  ### Methods declared in class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### WeakReference

    public WeakReference(T referent)
    Creates a new weak reference that refers to the given object. The new reference is not registered with any queue.
    Parameters:
      `referent` - object the new weak reference will refer to

  - ### WeakReference

    public WeakReference(T referent, ReferenceQueue<? super T> q)
    Creates a new weak reference that refers to the given object and is registered with the given queue.
    Parameters:
      `referent` - object the new weak reference will refer to
      `q` - the queue with which the reference is to be registered, or `null` if registration is not required